# Symantec C++ makefile for fractal example

WXDIR = $(WXWIN)
WXLIB = $(WXDIR)\lib\wx.lib
CTL3DLIB = $(WXDIR)\contrib\ctl3d\ctl3dv2.lib
FAFALIB = $(WXDIR)\contrib\fafa\fafa.lib
ITSYLIB = $(WXDIR)\contrib\itsybits\itsy.lib
INCDIR = $(WXDIR)\include
MSWINC = $(INCDIR)\msw
BASEINC = $(INCDIR)\base

CC=sc
RC=rc
CFLAGS = -o -ml -W -Dwx_msw
LDFLAGS = -ml -W

INCLUDE=$(BASEINC);$(MSWINC);$(WXDIR)\contrib\fafa

LIBS=$(WXLIB) libw.lib commdlg.lib shell.lib $(FAFALIB) $(ITSYLIB) $(CTL3DLIB)

.cc.obj:
	*$(CC) -c $(CFLAGS) -I$(INCLUDE) $<

.rc.res:
	*$(RC) -r -I$(INCLUDE) $<

fractal.exe: fractal.obj fractal.def fractal.res
	*$(CC) $(LDFLAGS) -o$@ fractal.obj fractal.def $(LIBS)
        *$(RC) -k fractal.res

clean:
        -del *.obj
	-del *.exe
	-del *.res
	-del *.map
	-del *.rws

