# Symantec C++ makefile for ipc example

WXDIR = $(WX)
WXLIB = $(WXDIR)\lib\wx.lib
CTL3DLIB = $(WXDIR)\contrib\ctl3d\ctl3d.lib
FAFALIB = $(WXDIR)\contrib\fafa\fafa.lib
INCDIR = $(WXDIR)\include
MSWINC = $(INCDIR)\msw
BASEINC = $(INCDIR)\base

CC=sc
RC=rc
CFLAGS = -o -ml -W -Dwx_msw
LDFLAGS = -ml -W

INCLUDE=$(BASEINC);$(MSWINC)

# LIBS=$(WXLIB) libw.lib commdlg.lib ddeml.lib shell.lib
# LIBS=$(WXLIB) libw.lib commdlg.lib ddeml.lib shell.lib $(CTL3DLIB)
LIBS=$(WXLIB) libw.lib commdlg.lib ddeml.lib shell.lib $(FAFALIB)

.cc.obj:
	*$(CC) -c $(CFLAGS) -I$(INCLUDE) $<

.rc.res:
	*$(RC) -r -I$(INCLUDE) $<

all: client.exe server.exe

client.exe: client.obj client.def client.res
	*$(CC) $(LDFLAGS) -o$@ client.obj client.def $(LIBS)
	*$(RC) -k client.res

server.exe: server.obj server.def server.res
	*$(CC) $(LDFLAGS) -o$@ server.obj server.def $(LIBS)
	*$(RC) -k server.res

clean:
        -del *.obj
	-del *.exe
	-del *.res
	-del *.map
	-del *.rws
